import React, { Component } from 'react';
import { NavLink } from 'react-router-dom';
import styled from 'styled-components';


const HeaderNav = styled.nav`
  background: #123;
  padding: 0.5em 1rem 0.125rem;
  display: flex;
  flex-flow: row wrap;
`;

const HeaderLink = styled(NavLink)`
  flex: 0 1 auto;
  padding: 0.5rem;
  margin: 0.25rem;
  font-size: 1.25rem;
  line-height: 1;
  color: #8af;

  :hover, :focus, :active {
    color: #acf;
  }

  &.active {
    color: #fff;
    text-decoration: none;
  }
`;

const HeaderSpacer = styled.span`
  flex: 1 0 0;
`;

const Content = styled.main`
  padding: 0 2rem;
`;


export default class App extends Component {

  render() {
    return (
      <div className="App">
        <HeaderNav>
          <HeaderLink exact to='/'>Home</HeaderLink>
          <HeaderLink to='/posts'>Posts</HeaderLink>
          <HeaderLink to='/categories'>Categories</HeaderLink>
          <HeaderLink to='/tags'>Tags</HeaderLink>
          <HeaderLink to='/pages'>Pages</HeaderLink>
          <HeaderSpacer />
          <HeaderLink as="a" href={process.env.REACT_APP_ADMIN}>Admin</HeaderLink>
        </HeaderNav>

        <Content>
          {this.props.children}
        </Content>
      </div>
    );
  }
}
