import React from 'react';
import { Switch, Route } from 'react-router-dom';

import Home from './Home';
import { PostsList, PostDetail } from './posts';
import { CategoriesList, CategoryDetail, TagsList, TagDetail } from './categories';
import { PagesList, PageDetail } from './pages';
import { UserDetail } from './users';
import NotFound from './NotFound';

export default () => (
  <Switch>
    <Route exact path="/" component={Home} />
    
    <Route path="/posts/detail/:id/:slug?" component={PostDetail} />
    <Route path="/posts/:page?" component={PostsList} />

    <Route path="/(categories)/:id/:slug?/posts/:page?" component={CategoryDetail} />
    <Route path="/categories" component={CategoriesList} />

    <Route path="/(tags)/:id/:slug?/posts/:page?" component={TagDetail} />
    <Route path="/tags" component={TagsList} />

    <Route path="/pages/detail/:id/:slug?" component={PageDetail} />
    <Route path="/pages/:page?" component={PagesList} />

    <Route path="/(author)/:id/:slug?/posts/:page?" component={UserDetail} />

    <Route component={NotFound} />
  </Switch>
);
