import { mapify } from '../utils';

import * as Consts from './constants';


const initialState = {
  categories: { },
  tags: { },
};

export default (state = initialState, action) => {
  switch (action.type) {
    case Consts.CATEGORIES_SUCCESS:
      return {...state,
        categories: {...state.categories,
          ...mapify(action.content),
        },
      };

    case Consts.TAGS_SUCCESS:
      return {...state,
        tags: {...state.tags,
          ...mapify(action.content),
        },
      };

    default:
      return state;
  }
}
