import * as Consts from './constants';


const initialState = {
  post: {
    // 1: { total: 2, items: [ { id: 10 }, { id: 20 } ] }
  },
  credentials: {
    email: undefined,
    name: undefined,
    url: undefined,
  }
};

export default (state = initialState, action) => {
  switch (action.type) {
    case Consts.FORPOST_SUCCESS:
      return {...state,
        post: {...state.post,
          [action.id]: {
            total: action.total,
            items: action.content,
          }
        }
      };

    case Consts.CREATE_SUCCESS:
      return {...state,
        post: {...state.post,
          [action.post]: {
            total: state.post[action.post].total +1,
            items: [
              action.comment,
              ...state.post[action.post].items,
            ],
          }
        },
        credentials: {
          email: action.email,
          name: action.name,
          url: action.url,
        },
      };

    default:
      return state;
  }
}
