import { } from 'redux-saga';
import { call, put, select, takeEvery } from 'redux-saga/effects';

import { getForPost, create } from './api';
import * as Consts from './constants';


function* loadForPost({id}) {
  try {
    const cached = yield select(state => state.comments.post[id]);
    if (!cached) {
      const response = yield call(getForPost, id);
      yield put({type: Consts.FORPOST_SUCCESS, ...response, id});
    }
  } catch (error) {
    console.error(error);
    yield put({type: Consts.FORPOST_FAIL, error});
  }
}

function* createNew({values:{content, email, name, url}, post, parent}) {
  try {
    const response = yield call(create, content, post, parent, email, name, url);
    yield put({type: Consts.CREATE_SUCCESS,
      comment: response.body, post, email, name, url});
  } catch (error) {
    console.error(error);
    yield put({type: Consts.CREATE_FAIL, error});
  }
}

export default function* commentsFlow() {
  yield takeEvery(Consts.FORPOST_REQUEST, loadForPost);
  yield takeEvery(Consts.CREATE_REQUEST, createNew);
}
