import React from 'react';
import ReactDOM from 'react-dom';
import { BrowserRouter, HashRouter } from 'react-router-dom';
import { createStore, applyMiddleware } from 'redux';
import { Provider } from 'react-redux';
import createSagaMiddleware from 'redux-saga';

import { register } from './serviceWorker';
import App from './App';
import Routes from './Routes';
import reducer from './reducers';
import saga from './sagas';
import Styles from './styles';


const sagaMiddleware = createSagaMiddleware();
const store = createStore(reducer,
  applyMiddleware(sagaMiddleware),
);
  
sagaMiddleware.run(saga);

const Router = process.env.REACT_APP_ROUTER_BROWSERHISTORY ? BrowserRouter : HashRouter;
ReactDOM.render(
  <Provider store={store}>
    <Styles />
    <Router basename={process.env.REACT_APP_ROUTER_BASE}>
      <App>
        <Routes />
      </App>
    </Router>
  </Provider>
, document.getElementById('root')
);


// If you want your app to work offline and load faster, you can change
// unregister() to register() below. Note this comes with some pitfalls.
// Learn more about service workers: http://bit.ly/CRA-PWA
register();
