import React, { Component } from 'react';
import { withRouter } from 'react-router-dom';
import { connect } from 'react-redux';

import * as Consts from './constants';

import Page from './Page';


class DetailContainer extends Component {

  componentDidMount() {
    this.props.load(this.props.id);
  }

  componentDidUpdate(prevProps) {
    if (this.props.id !== prevProps.id) {
      this.props.load(this.props.id);
    }
  }

  render() {
    const {page} = this.props;
  
    return (
      <Page page={page} full />
    );
  }
}


const mapState = (state, ownProps) => {
  const id = ownProps.id || ownProps.match.params.id;

  return {
    id,
    page: state.pages.byId[id],
  };
};

const mapDispatch = (dispatch) => ({
  load: (id) => dispatch({type: Consts.DETAIL_REQUEST, id}),
});

export default withRouter(connect(mapState, mapDispatch)(DetailContainer));
