import { mapify } from '../utils';

import * as Consts from './constants';


const initialState = {
  byId: {
    // 1: { id: 1, ..., author: 2, }
  },
  all: [], // "view all" rather than every single one, in order for paging
  total: null,
};

export default (state = initialState, action) => {
  switch (action.type) {
    case Consts.LIST_SUCCESS: {
      // splice doesn't work the way we want with a smaller array than start; also we create a copy, since splice modifies the array
      const all = state.all.length === 0
        ? Array(action.total)
        : [...state.all];
      all.splice(action.start, action.amount, ...action.content.map(a => a.id));
      return {...state,
        byId: {...state.byId,
          ...mapify(action.content)
        },
        all,
        total: action.total,
      };
    }

  case Consts.DETAIL_SUCCESS:
    return {...state,
      byId: {...state.byId,
        [action.id]: action.content,
      },
    };

  case Consts.DETAIL_FAIL:
    return {...state,
      byId: {...state.byId,
        [action.id]: 404,
      },
    };

  default:
    return state;
}
}
