import React, { Component } from 'react';
import { withRouter } from 'react-router-dom';
import { connect } from 'react-redux';

import * as Consts from './constants';

import Post from './Post';


class DetailContainer extends Component {

  componentDidMount() {
    this.props.load(this.props.id);
  }

  componentDidUpdate(prevProps) {
    if (this.props.id !== prevProps.id) {
      this.props.load(this.props.id);
    }
  }

  render() {
    const {post, backLink} = this.props;
  
    return (
      <Post post={post} full link={backLink} />
    );
  }
}


const mapState = (state, ownProps) => {
  const id = ownProps.id || ownProps.match.params.id;

  return {
    id,
    backLink: ownProps.location.state,
    post: state.posts.byId[id],
  };
};

const mapDispatch = (dispatch) => ({
  load: (id) => dispatch({type: Consts.DETAIL_REQUEST, id}),
});

export default withRouter(connect(mapState, mapDispatch)(DetailContainer));
