import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { withRouter } from 'react-router-dom';
import { connect } from 'react-redux';

import * as Consts from './constants';

import Embed from './Embed';
import Profile from './Profile';


class DetailContainer extends Component {

  static propTypes = {
    embed: PropTypes.bool,

    //opt: import {UserShape} from './propTypes'; PropTypes.arrayOf(UserShape),
    user: PropTypes.object,
  }

  componentDidMount() {
    this.props.load(this.props.id);
  }

  componentDidUpdate(prevProps) {
    if (this.props.id !== prevProps.id) {
      this.props.load(this.props.id);
    }
  }

  render() {
    const {embed, user} = this.props;

    return embed ? (
      <Embed user={user} />
      ) : (
      <Profile user={user} />
    );
  }
}


const mapState = (state, ownProps) => {
  const id = ownProps.id || (!ownProps.embed && ownProps.match.params.id);

  return {
    embed: ownProps.embed,
    id,
    user: state.users[id],
  };
};

const mapDispatch = (dispatch) => ({
  load: (id) => id && dispatch({type: Consts.REQUEST, id}),
});

export default withRouter(connect(mapState, mapDispatch)(DetailContainer));
