import React, { PureComponent } from 'react';
import PropTypes from 'prop-types';
import { Link } from 'react-router-dom';
import styled from 'styled-components';

import { TextPlaceholder, InlineImage } from '../styles';


const Wrapper = styled(Link)`
  color: inherit;
`;


export default class Embed extends PureComponent {
  
  static propTypes = {
    //OPT: import {UserShape} from './propTypes'; post: UserShape,
    user: PropTypes.object,
  };

  render() {
    const {user, className} = this.props;

    return !user ? (
      <Wrapper as="span" className={className}>
        <TextPlaceholder />
      </Wrapper>
    ) : !user.id ? (
      <Wrapper as={user.url ? 'a' : 'span'} href={user.url || undefined} className={className}>
        <InlineImage src={user.avatar_urls[24]} />
        <span>{user.name}</span>
      </Wrapper>
    ) : (
      <Wrapper to={`/author/${user.id}/${user.slug}/posts`} className={className}>
        <InlineImage src={user.avatar_urls[24]} />
        <span>{user.name}</span>
      </Wrapper>
    );
  }
}
