import { } from 'redux-saga';
import { call, put, select, takeEvery } from 'redux-saga/effects';

import { get } from './api';
import * as Consts from './constants';


function* load({id}) {
  try {
    if (!(yield select(state => state.users[id]))) {
      const content = yield call(get, id);
      yield put({type: Consts.SUCCESS, content});
    }
  } catch (error) {
    console.error(error);
    yield put({type: Consts.FAIL, error});
  }
}

export default function* usersFlow() {
  yield takeEvery(Consts.REQUEST, load);
}
